#include <bits/stdc++.h>

using namespace std;

int n,k;
int a[500005];
bool b[500005];

int main()
{
    scanf("%d%d",&n,&k);
    for(int i=0; i<n; i++)
        scanf("%d",a+i);
    int ai=0;
    for(int i=0; i<n; i++)
        if(a[i]>ai)
            ai=a[i];
    if(ai<=1)
    {
        for(int i=0; i<n; i++)
        {
            if(k==0) break;
            if(a[i]==1)
            {
                b[i]=true;
                k--;
            }
        }
        for(int i=0; i<n; i++)
        {
            if(k==0) break;
            if(!b[i])
            {
                b[i]=true;
                k--;
            }
        }
        for(int i=0; i<n; i++)
            if(!b[i])
                cout<<a[i]<<" ";

    }


    else
    {   int mk=0;
        while(k>0)
        {
            int mini=2000000005;
            int minind=mk;
            for(int i=mk; i<mk+k+1; i++)
            {
                if(a[i]<mini)
                {
                    mini=a[i];
                    minind=i;
                }
            }
            for(int i=mk; i<minind; i++)
            {
                b[i]=true;
                k--;
            }
            mk=minind+1;
        }
        if(k>0)
        {
            for(int i=n-1; ; i--)
            {
                if(k==0) break;
                b[i]=false;
            }
        }
        for(int i=0; i<n; i++)
            if(!b[i])
                printf("%d ",a[i]);

    }

    return 0;
}